package com.example.coachlea.data_access;

import android.database.Cursor;
import android.database.sqlite.SQLiteStatement;

import org.greenrobot.greendao.AbstractDao;
import org.greenrobot.greendao.Property;
import org.greenrobot.greendao.database.Database;
import org.greenrobot.greendao.database.DatabaseStatement;
import org.greenrobot.greendao.internal.DaoConfig;

// THIS CODE IS GENERATED BY greenDAO, DO NOT EDIT.

/**
 * DAO for table "PATIENT_DA".
*/
public class PatientDADao extends AbstractDao<PatientDA, Long> {

    public static final String TABLENAME = "PATIENT_DA";

    /**
     * Properties of entity PatientDA.<br/>
     * Can be used for QueryBuilder and for referencing column names.
     */
    public static class Properties {
        public final static Property UserId = new Property(0, Long.class, "userId", true, "_id");
        public final static Property GovtId = new Property(1, String.class, "govtId", false, "GOVT_ID");
        public final static Property Username = new Property(2, String.class, "username", false, "USERNAME");
        public final static Property Birthday = new Property(3, java.util.Date.class, "birthday", false, "BIRTHDAY");
        public final static Property Gender = new Property(4, String.class, "gender", false, "GENDER");
        public final static Property Side = new Property(5, String.class, "side", false, "SIDE");
        public final static Property Smoker = new Property(6, boolean.class, "smoker", false, "SMOKER");
        public final static Property Type = new Property(7, boolean.class, "type", false, "TYPE");
    }


    public PatientDADao(DaoConfig config) {
        super(config);
    }
    
    public PatientDADao(DaoConfig config, DaoSession daoSession) {
        super(config, daoSession);
    }

    /** Creates the underlying database table. */
    public static void createTable(Database db, boolean ifNotExists) {
        String constraint = ifNotExists? "IF NOT EXISTS ": "";
        db.execSQL("CREATE TABLE " + constraint + "\"PATIENT_DA\" (" + //
                "\"_id\" INTEGER PRIMARY KEY AUTOINCREMENT ," + // 0: userId
                "\"GOVT_ID\" TEXT," + // 1: govtId
                "\"USERNAME\" TEXT," + // 2: username
                "\"BIRTHDAY\" INTEGER," + // 3: birthday
                "\"GENDER\" TEXT," + // 4: gender
                "\"SIDE\" TEXT," + //5: side
                "\"SMOKER\" INTEGER NOT NULL ," + // 6: smoker
                "\"TYPE\" INTEGER NOT NULL );"); //7: type
    }

    /** Drops the underlying database table. */
    public static void dropTable(Database db, boolean ifExists) {
        String sql = "DROP TABLE " + (ifExists ? "IF EXISTS " : "") + "\"PATIENT_DA\"";
        db.execSQL(sql);
    }

    @Override
    protected final void bindValues(DatabaseStatement stmt, PatientDA entity) {
        stmt.clearBindings();
 
        Long userId = entity.getUserId();
        if (userId != null) {
            stmt.bindLong(1, userId);
        }
 
        String govtId = entity.getGovtId();
        if (govtId != null) {
            stmt.bindString(2, govtId);
        }
 
        String username = entity.getUsername();
        if (username != null) {
            stmt.bindString(3, username);
        }
 
        java.util.Date birthday = entity.getBirthday();
        if (birthday != null) {
            stmt.bindLong(4, birthday.getTime());
        }
 
        String gender = entity.getGender();
        if (gender != null) {
            stmt.bindString(5, gender);
        }
        String side = entity.getSide();
        if(side != null) {
            stmt.bindString(6, side);
        }
        stmt.bindLong(7, entity.getSmoker() ? 1L: 0L);
        String type = entity.getType();
        if(type != null) {
            stmt.bindString(8, type);
        }
    }

    @Override
    protected final void bindValues(SQLiteStatement stmt, PatientDA entity) {
        stmt.clearBindings();
 
        Long userId = entity.getUserId();
        if (userId != null) {
            stmt.bindLong(1, userId);
        }
 
        String govtId = entity.getGovtId();
        if (govtId != null) {
            stmt.bindString(2, govtId);
        }
 
        String username = entity.getUsername();
        if (username != null) {
            stmt.bindString(3, username);
        }
 
        java.util.Date birthday = entity.getBirthday();
        if (birthday != null) {
            stmt.bindLong(4, birthday.getTime());
        }
 
        String gender = entity.getGender();
        if (gender != null) {
            stmt.bindString(5, gender);
        }
        String side = entity.getSide();
        if(side != null) {
            stmt.bindString(6, side);
        }
        stmt.bindLong(7, entity.getSmoker() ? 1L: 0L);
        String type = entity.getType();
        if(type != null) {
            stmt.bindString(8, type);
        }
    }

    @Override
    public Long readKey(Cursor cursor, int offset) {
        return cursor.isNull(offset + 0) ? null : cursor.getLong(offset + 0);
    }    

    @Override
    public PatientDA readEntity(Cursor cursor, int offset) {
        PatientDA entity = new PatientDA( //
            cursor.isNull(offset + 0) ? null : cursor.getLong(offset + 0), // userId
            cursor.isNull(offset + 1) ? null : cursor.getString(offset + 1), // govtId
            cursor.isNull(offset + 2) ? null : cursor.getString(offset + 2), // username
            cursor.isNull(offset + 3) ? null : new java.util.Date(cursor.getLong(offset + 3)), // birthday
            cursor.isNull(offset + 4) ? null : cursor.getString(offset + 4), // gender
            cursor.isNull(offset + 5) ? null : cursor.getString(offset + 5), // side
                cursor.getShort(offset + 6) != 0, // smoker
                cursor.isNull(offset + 7) ? null : cursor.getString(offset + 7) // type
        );
        return entity;
    }
     
    @Override
    public void readEntity(Cursor cursor, PatientDA entity, int offset) {
        entity.setUserId(cursor.isNull(offset + 0) ? null : cursor.getLong(offset + 0));
        entity.setGovtId(cursor.isNull(offset + 1) ? null : cursor.getString(offset + 1));
        entity.setUsername(cursor.isNull(offset + 2) ? null : cursor.getString(offset + 2));
        entity.setBirthday(cursor.isNull(offset + 3) ? null : new java.util.Date(cursor.getLong(offset + 3)));
        entity.setGender(cursor.isNull(offset + 4) ? null : cursor.getString(offset + 4));
        entity.setSide(cursor.isNull(offset + 5) ? null : cursor.getString(offset + 5));
        entity.setSmoker(cursor.getShort(offset + 6) != 0);
        entity.setType(cursor.isNull(offset + 7) ? null : cursor.getString(offset + 7));
     }
    
    @Override
    protected final Long updateKeyAfterInsert(PatientDA entity, long rowId) {
        entity.setUserId(rowId);
        return rowId;
    }
    
    @Override
    public Long getKey(PatientDA entity) {
        if(entity != null) {
            return entity.getUserId();
        } else {
            return null;
        }
    }

    @Override
    public boolean hasKey(PatientDA entity) {
        return entity.getUserId() != null;
    }

    @Override
    protected final boolean isEntityUpdateable() {
        return true;
    }
    
}
